diff -Naur arXiv-1.01.orig/lib/arXiv/FileGuess.pm arXiv-1.01/lib/arXiv/FileGuess.pm
--- arXiv-1.01.orig/lib/arXiv/FileGuess.pm	2010-12-25 18:37:06.000000000 +0100
+++ arXiv-1.01/lib/arXiv/FileGuess.pm	2020-04-17 13:13:37.854023355 +0200
@@ -205,7 +205,7 @@
   return 'TYPE_PDF' if index($one_kb, '%PDF-') >= 0;
   return 'TYPE_MAC' if $one_kb =~ /#!\/bin\/csh -f\r#|(\r|^)begin \d{1,4}\s+\S.*\r[^\n]/;
 
-  my ($maybe_tex, $maybe_tex_priority, $maybe_tex_priority2);
+  my ($maybe_latex, $maybe_tex, $maybe_tex_priority, $maybe_tex_priority2);
   seek($FILE_TO_GUESS, 0, 0);
 
   local $/ = "\n";
@@ -262,7 +262,10 @@
     if (/(^|\r)\s*\\documentclass/) {
       return _type_of_latex2e(\*{$FILE_TO_GUESS});
     }
-    if (/(^|\r)\s*(\\font|\\magnification|\\input|\\def|\\special|\\baselineskip|\\begin)/) {
+    if (/(^|\r)\s*(\\begin|\\section|\\subsection|\\subsubsection|\\usepackage)/) {
+      $maybe_latex = 1;
+    }
+    if (/(^|\r)\s*(\\font|\\magnification|\\input|\\def|\\special|\\baselineskip)/) {
       $maybe_tex = 1;
       return 'TYPE_TEX_priority' if /\\input\s+amstex/;
     }
@@ -291,6 +294,9 @@
       return 'TYPE_ALWAYS_IGNORE'; # Was 'TYPE_FAILED'
     }
   }
+
+  return _type_of_latex2e(\*{$FILE_TO_GUESS}) if $maybe_latex;
+
   close $FILE_TO_GUESS || warn "couldn't close file: $!";
 
   return 'TYPE_TEX_priority' if $maybe_tex_priority;
